﻿using System;
using System.Runtime.CompilerServices;
using System.Runtime.ConstrainedExecution;
using System.Threading;

namespace ConstrainedExecutedRegion
{
    class Program
    {
        static void Main(string[] args)
        {
            var cerThread = new Thread(() =>
            {
                try
                {
                    DoCER();
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.ToString());
                }

                Console.WriteLine("TEST2");
            })
            {
                Name = "CER thread"
            };
            cerThread.Start();

            cerThread.Join();

            Console.WriteLine("Join");
        }

        private static void DoCER()
        {
            Console.WriteLine("Not even executed!");
            RuntimeHelpers.PrepareConstrainedRegions();
            try
            {
            }
            finally
            {
                Console.WriteLine("In finally: " + DateTime.Now);
                OutOfMemory();
            }
        }

        [ReliabilityContract(Consistency.WillNotCorruptState, Cer.MayFail)]
        // [ReliabilityContract(Consistency.MayCorruptInstance, Cer.MayFail)]
        static void OutOfMemory()
        {
            Big big;
        }
    }

    unsafe struct Big
    {
        public fixed byte Bytes[int.MaxValue];
    }
}